// Demo_WinDllDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "Def.h"
#include "Demo_WinDll.h"
#include "Demo_WinDllDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// Vom Klassenassistenten generierte berladungen virtueller Funktionen
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	//}}AFX_VIRTUAL

// Implementierung
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// Keine Nachrichten-Handler
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemo_WinDllDlg Dialogfeld

CDemo_WinDllDlg::CDemo_WinDllDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemo_WinDllDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDemo_WinDllDlg)
	m_EnableBySoftware = FALSE;
	m_EncoderIndexFound = FALSE;
	m_HallSensorFound = FALSE;
	m_PowerStageEnabled = FALSE;
	m_RotorPositionFound = FALSE;
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDemo_WinDllDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDemo_WinDllDlg)
	DDX_Control(pDX, IDC_CommunicationSetting, m_CommunicationSetting);
	DDX_Control(pDX, IDC_StopMotion, m_StopMotion);
	DDX_Control(pDX, IDC_SetVelocity, m_SetVelocity);
	DDX_Control(pDX, IDC_Enable, m_Enable);
	DDX_Control(pDX, IDC_Disable, m_Disable);
	DDX_Check(pDX, IDC_EnableBySoftware, m_EnableBySoftware);
	DDX_Check(pDX, IDC_EncoderIndexFound, m_EncoderIndexFound);
	DDX_Check(pDX, IDC_HalloSensorFound, m_HallSensorFound);
	DDX_Check(pDX, IDC_PowerStageEnabled, m_PowerStageEnabled);
	DDX_Check(pDX, IDC_RotorPositionFound, m_RotorPositionFound);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDemo_WinDllDlg, CDialog)
	//{{AFX_MSG_MAP(CDemo_WinDllDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CommunicationSetting, OnCommunicationSetting)
	ON_BN_CLICKED(IDC_Disable, OnDisable)
	ON_BN_CLICKED(IDC_Enable, OnEnable)
	ON_BN_CLICKED(IDC_SetVelocity, OnSetVelocity)
	ON_BN_CLICKED(IDC_StopMotion, OnStopMotion)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemo_WinDllDlg Nachrichten-Handler

BOOL CDemo_WinDllDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Hinzufgen des Menbefehls "Info..." zum Systemmen.

	// IDM_ABOUTBOX muss sich im Bereich der Systembefehle befinden.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if(pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if(!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden

	//DES Initialisation
	__int32 baudrate = 38400;
	strcpy(m_Port,"Com1");
	DWORD timeout = 200;
	DWORD trials = 4;

	m_MsgBox = TRUE;
	m_SetVelocity.EnableWindow(true);
	m_StopMotion.EnableWindow(false);

	DES_InitCommunication(m_Port,baudrate,timeout,trials);
	InitDES();
	UpdateStatus();
	//End DES Initialisation

	return TRUE; // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CDemo_WinDllDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CDemo_WinDllDlg::OnPaint() 
{
	if(IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CDemo_WinDllDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDemo_WinDllDlg::OnCommunicationSetting() 
{
	DES_InitCommunicationDlg(m_Port);
	InitDES();
}

void CDemo_WinDllDlg::OnDisable() 
{
	if(!DES_Enable(m_Port,0))
	{
		KillTimer(1);
		AfxMessageBox("Communcation error");
		m_MsgBox = FALSE;
	}
}

void CDemo_WinDllDlg::OnEnable() 
{
	if(!DES_Enable(m_Port,1))
	{
		KillTimer(1);
		AfxMessageBox("Communcation error");
		m_MsgBox = FALSE;
	}
	else
	{
		m_SetVelocity.EnableWindow(true);
		m_StopMotion.EnableWindow(false);
		m_CommunicationSetting.EnableWindow(false);
	}
}

void CDemo_WinDllDlg::OnSetVelocity() 
{
	if(!DES_SetVelocity(m_Port,1000))
	{
		KillTimer(1);
		AfxMessageBox("Communcation error");
		m_MsgBox = FALSE;
	}
	else
	{
		m_SetVelocity.EnableWindow(false);
		m_StopMotion.EnableWindow(true);
	}
}

void CDemo_WinDllDlg::OnStopMotion() 
{
	if(!DES_SetVelocity(m_Port,0))
	{
		KillTimer(1);
		AfxMessageBox("Communcation error");
		m_MsgBox = FALSE;
	}
	else
	{
		m_SetVelocity.EnableWindow(true);
		m_StopMotion.EnableWindow(false);
	}
}

void CDemo_WinDllDlg::OnTimer(UINT nIDEvent) 
{
	if(!UpdateStatus())
	{
		KillTimer(1);
		AfxMessageBox("Communcation error");
		m_MsgBox = FALSE;
	}

	CDialog::OnTimer(nIDEvent);
}

BOOL CDemo_WinDllDlg::InitDES()
{
	BOOL result = TRUE;
	WORD sysConfig = 0x9000; //Speed Regulation; SetValue by software; Enable by software;
	WORD dummy;

	if(result && !DES_ReadTempParam(m_Port,1,0,&m_SysConfig)) result = FALSE;

	//EnableBySoftware
	dummy = m_SysConfig;
	dummy |= 0x1000;
	if(result && !DES_SetTempParam(m_Port,1,0,&dummy)) result = FALSE;
	if(result && !DES_Enable(m_Port,0)) result = FALSE;

	//Set new sysConfig
	if(result && !DES_SetTempParam(m_Port,1,0,&sysConfig)) result = FALSE;

	SetTimer(1,200,NULL);

	return result;
}

BOOL CDemo_WinDllDlg::RestoreDES()
{
	BOOL result = TRUE;
	WORD sysConfig;
	WORD dummy;

	if(result && !DES_ReadTempParam(m_Port,1,0,&sysConfig)) result = FALSE;

	//EnableBySoftware
	dummy = sysConfig;
	dummy |= 0x1000;
	if(result && !DES_SetTempParam(m_Port,1,0,&dummy)) result = FALSE;
	if(result && !DES_Enable(m_Port,0)) result = FALSE;

	//Set new sysConfig
	if(result && !DES_SetTempParam(m_Port,1,0,&m_SysConfig)) result = FALSE;

	if(!result && m_MsgBox)
	{
		AfxMessageBox("Communcation error");
		m_MsgBox = FALSE;
	}

	KillTimer(1);
	if(result) DES_CloseCommunication(m_Port);

	return result;
}

BOOL CDemo_WinDllDlg::UpdateStatus()
{
	BOOL result = TRUE;
	WORD status;

	if(result && !DES_ReadSysStatus(m_Port,&status)) result = FALSE;

	if(result)
	{
		if((status & 0x0001) > 0) m_EncoderIndexFound = TRUE; else m_EncoderIndexFound = FALSE;
		if((status & 0x0002) > 0) m_HallSensorFound = TRUE; else m_HallSensorFound = FALSE;
		if((status & 0x0004) > 0) m_RotorPositionFound = TRUE; else m_RotorPositionFound = FALSE;

		if((status & 0x4000) > 0) m_PowerStageEnabled = TRUE; else m_PowerStageEnabled = FALSE;
		if((status & 0x0400) > 0) m_EnableBySoftware = TRUE; else m_EnableBySoftware = FALSE;
	}
	else
	{
		m_EncoderIndexFound = FALSE;
		m_HallSensorFound = FALSE;
		m_RotorPositionFound = FALSE;

		m_PowerStageEnabled = FALSE;
		m_EnableBySoftware = FALSE;
	}

	m_Disable.EnableWindow(m_PowerStageEnabled);
	m_Enable.EnableWindow(!m_PowerStageEnabled);
	m_CommunicationSetting.EnableWindow(!m_PowerStageEnabled);

	if(!m_PowerStageEnabled)
	{
		m_SetVelocity.EnableWindow(m_PowerStageEnabled);
		m_StopMotion.EnableWindow(m_PowerStageEnabled);
	}

	if(m_hWnd) UpdateData(false);

	return result;
}

BOOL CDemo_WinDllDlg::DestroyWindow() 
{
	RestoreDES();

	return CDialog::DestroyWindow();
}




